using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace LunarDestroyer
{
	/// <summary>
	/// Implementacia Asteroidu do hry Lunar Destroyer.
	/// </summary>
	public class Asteroid
	{
		public Point pPozicia = new Point();	//suradnice
		private int iPriemer;					//priemer
		private Bitmap imgAsteroid = null;		//obrazok asteroidu
		private Bitmap imgExplozia = null;		//obrazok explozie
		private float fSmer;					//smer pohybu
		private int iRychlost;					//rychlost
		private bool bKolStop = false;			//kolizia?
		private bool bAktivny;					//je aktivny
		private int iExplSekv = 0;				//poradie v sekvencii explozie
		private int iExplPocet = 17;			//pocet animacii v explozii
		private string sAstVybuchPreffix = "vybuch";	//retazec pre skratenie mena obrazka vybuchu
		//konstruktor
		/*public Asteroid()
		{
			// nastavenie premennych
			pPozicia.X = 50;
			pPozicia.Y = 50;
			iRychlost = 0;
			fSmer = 0;
			bAktivny = true;

			Random rand = new Random();

			if (imgAsteroid == null)
			{
				imgAsteroid = (Bitmap)Image.FromFile("Asteroid" + rand.Next(3) + ".gif");
			}
			if (imgExplozia == null)
			{
				imgExplozia = (Bitmap)Image.FromFile("Explosion.gif");
			}
			iPriemer = imgAsteroid.Width;
		}*/
		//jeho overload
		public Asteroid(int _startX, int _startY, float _smer)
		{
			pPozicia.X = _startX;
			pPozicia.Y = _startY;
			iRychlost = 6;
			fSmer = _smer;
			bAktivny = true;

			Random rand = new Random();

			if (imgAsteroid == null)
			{
				imgAsteroid = (Bitmap)Image.FromFile("Asteroid" + rand.Next(3) + ".gif");
			}

			iPriemer = imgAsteroid.Width/2;
			imgAsteroid.MakeTransparent(Color.Black);
		}
		//vykresli asteroid pripadne i jeho exploziu
		public void Kresli(Graphics _kresli)
		{
			if (iExplSekv == 0)	//nie je explozia
			{
				//vytvori mapu obrazku
				Rectangle stvorec = new Rectangle(pPozicia.X, pPozicia.Y, iPriemer, iPriemer);
				//vykresli
				_kresli.DrawImage(imgAsteroid, stvorec,0,0,imgAsteroid.Width,imgAsteroid.Height,GraphicsUnit.Pixel);
			}
			else	//explozia
			{
				//vykresli exploziu
				VykresliExpl(_kresli);
				iExplSekv++;
				if (iExplSekv > iExplPocet)
					bAktivny=false;
			}
		}
		//vykresli exploziu
		private void VykresliExpl(Graphics _kresli)
		{
			//vytvori novy stvoruholnik
			Rectangle stvorec = new Rectangle(pPozicia.X, pPozicia.Y, iPriemer, iPriemer);
			//vyberie ten spravny subor v sekvencii
			imgExplozia = (Bitmap)Image.FromFile(sAstVybuchPreffix + iExplSekv + ".gif");
			imgExplozia.MakeTransparent(Color.Black);
			//vykresli
			_kresli.DrawImage(imgExplozia, stvorec,0,0,imgExplozia.Width,imgExplozia.Height, GraphicsUnit.Pixel);
		}
		//vytvori novy objekt stvorec reprezentujuci aktualnu poziciu
		public Rectangle Okraje()
		{
			return new Rectangle(pPozicia.X, pPozicia.Y, iPriemer, iPriemer);
		}
		//pohne asteroidom
		public void Pohyb()
		{
			// vypocet novych suradnic pomocou rychlosti a vektora smeru
			int iNewX = (int)(iRychlost * System.Math.Sin((System.Math.PI*fSmer)/180));
			int iNewY = -(int)(iRychlost * System.Math.Cos((System.Math.PI*fSmer)/180));

			pPozicia.X = pPozicia.X + iNewX;
			pPozicia.Y = pPozicia.Y + iNewY;
		}
		/*-------------vlastnosti----------------*/
		//vrati stred asteroidu
		public Point Stred
		{
			get 
			{
				return new Point(pPozicia.X+this.AsteroidImg.Width/2,pPozicia.Y+this.AsteroidImg.Height/2);
			}
		}
		public int Rychlost
		{
			get 
			{
				return iRychlost;
			}
			set
			{
				iRychlost = value;
			}
		}
		public float Smer
		{
			get
			{
				return fSmer;
			}
		}

		public bool Aktivny
		{
			get 
			{
				return bAktivny;
			}
			set
			{
				bAktivny = value;
			}
		}
		public bool Exploduje
		{
			get 
			{
				if (iExplSekv == 0)
					return false;
				else
					return true;
			}
			set
			{
				iExplSekv = 1;
			}
		}
		//test ci sa nachadza vo formulary
		public bool VnutriStvorca(Rectangle _stvorecTest)
		{
			bool bHit = true;
			if (pPozicia.X < _stvorecTest.X)
			{
				if (bKolStop)
					pPozicia.X = _stvorecTest.X;
				else
					pPozicia.X = _stvorecTest.Right - -(pPozicia.X);
				bHit = false;
			}
			if (pPozicia.X > _stvorecTest.Right)
			{
				if (bKolStop)
					pPozicia.X = _stvorecTest.Right - iPriemer;
				else
					pPozicia.X = _stvorecTest.X + (_stvorecTest.Right - pPozicia.X); 
				bHit = false;
			}
				
			if (pPozicia.Y < _stvorecTest.Y) 
			{
				if (bKolStop)
					pPozicia.Y = _stvorecTest.Y;
				else
					pPozicia.Y = _stvorecTest.Bottom - -(pPozicia.Y);
				bHit = false;
			}
				
			if (pPozicia.Y > _stvorecTest.Bottom)
			{
				if (bKolStop)
					pPozicia.Y = _stvorecTest.Bottom - iPriemer;
				else
					pPozicia.Y = _stvorecTest.Y + (_stvorecTest.Bottom - pPozicia.Y); 
				bHit = false;
			}
			return bHit;
		}
		//obrazok
		public Bitmap AsteroidImg
		{
			get
			{
				return new Bitmap(imgAsteroid,iPriemer,iPriemer);
			}
		}
	}
}
