using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace LunarDestroyer
{
	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class LForm : System.Windows.Forms.Form
	{
		private int NadpisPos = 1;			//posun textu o pocet
		private bool bZac = false;			//zaciatok hry
        private bool bPauza = false;		//pozastavenie hry
		private ArrayList AsteroidList;		//pole asteroidov
		private vesLod Hrac1 = null, Hrac2 = null;	//obaja hraci typu vesLod 
													//pre polymorfismus
		private int iHrac = 0;				//urcuje kto hra, 0-hrac,1-pocitac,2-obaja,
											//3-dvaja hraci,4-dva pocitace
		private bool bDuel = false;			// i asteroidy
		private int iPocetAst = 1;			//pocet asteroidov
		private int Skore1,Skore2;			//skore hracov

        //zakladne komponenty na formulary
		private System.Windows.Forms.MenuItem mnuNova;
		private System.Windows.Forms.MenuItem mnuUkonc;
		private System.Windows.Forms.MainMenu mnuLunar;
		private System.Windows.Forms.Timer Ltimer;
		private System.Windows.Forms.MenuItem mnuHra;
		private System.Windows.Forms.MenuItem mnuPomoc;
		private System.Windows.Forms.MenuItem mnuOhre;
		private System.Windows.Forms.MenuItem mnuNastavenia;
		private System.Windows.Forms.MenuItem mnuZotrvacnost;
		private System.Windows.Forms.MenuItem mnuPauza;
		private System.Windows.Forms.MenuItem mnuPom;
		private System.ComponentModel.IContainer components;

		public LForm()
		{

			InitializeComponent();
			//pre double buffering - rychlejsie vykreslovanie
			SetStyle(ControlStyles.UserPaint, true);
			SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.DoubleBuffer, true);

			Inicializuj();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.mnuLunar = new System.Windows.Forms.MainMenu();
			this.mnuHra = new System.Windows.Forms.MenuItem();
			this.mnuNova = new System.Windows.Forms.MenuItem();
			this.mnuUkonc = new System.Windows.Forms.MenuItem();
			this.mnuNastavenia = new System.Windows.Forms.MenuItem();
			this.mnuZotrvacnost = new System.Windows.Forms.MenuItem();
			this.mnuPomoc = new System.Windows.Forms.MenuItem();
			this.mnuOhre = new System.Windows.Forms.MenuItem();
			this.Ltimer = new System.Windows.Forms.Timer(this.components);
			this.mnuPom = new System.Windows.Forms.MenuItem();
			this.mnuPauza = new System.Windows.Forms.MenuItem();
			// 
			// mnuLunar
			// 
			this.mnuLunar.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.mnuHra,
																					 this.mnuNastavenia,
																					 this.mnuPomoc});
			// 
			// mnuHra
			// 
			this.mnuHra.Index = 0;
			this.mnuHra.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				   this.mnuNova,
																				   this.mnuPauza,
																				   this.mnuUkonc});
			this.mnuHra.Text = "&Hra";
			// 
			// mnuNova
			// 
			this.mnuNova.Index = 0;
			this.mnuNova.Shortcut = System.Windows.Forms.Shortcut.F9;
			this.mnuNova.Text = "&Nov";
			this.mnuNova.Click += new System.EventHandler(this.mnuNova_Click);
			// 
			// mnuUkonc
			// 
			this.mnuUkonc.Index = 2;
			this.mnuUkonc.Shortcut = System.Windows.Forms.Shortcut.F10;
			this.mnuUkonc.Text = "&Ukoni";
			this.mnuUkonc.Click += new System.EventHandler(this.mnuUkonc_Click);
			// 
			// mnuNastavenia
			// 
			this.mnuNastavenia.Index = 1;
			this.mnuNastavenia.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.mnuZotrvacnost});
			this.mnuNastavenia.Text = "&Zotrvanos";
			// 
			// mnuZotrvacnost
			// 
			this.mnuZotrvacnost.Checked = true;
			this.mnuZotrvacnost.Index = 0;
			this.mnuZotrvacnost.Text = "Zotrvacnost striel";
			this.mnuZotrvacnost.Click += new System.EventHandler(this.mnuZotrvacnost_Click);
			// 
			// mnuPomoc
			// 
			this.mnuPomoc.Index = 2;
			this.mnuPomoc.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.mnuOhre,
																					 this.mnuPom});
			this.mnuPomoc.Text = "&Pomoc";
			// 
			// mnuOhre
			// 
			this.mnuOhre.Index = 0;
			this.mnuOhre.Text = "&O hre";
			this.mnuOhre.Click += new System.EventHandler(this.mnuOhre_Click);
			// 
			// Ltimer
			// 
			this.Ltimer.Enabled = true;
			this.Ltimer.Tick += new System.EventHandler(this.Ltimer_Tick);
			// 
			// mnuPom
			// 
			this.mnuPom.Index = 1;
			this.mnuPom.Shortcut = System.Windows.Forms.Shortcut.F1;
			this.mnuPom.Text = "&Pomoc";
			this.mnuPom.Click += new System.EventHandler(this.mnuPom_Click);
			// 
			// mnuPauza
			// 
			this.mnuPauza.Index = 1;
			this.mnuPauza.Shortcut = System.Windows.Forms.Shortcut.F8;
			this.mnuPauza.Text = "&Pauza";
			this.mnuPauza.Click += new System.EventHandler(this.mnuPauza_Click);
			// 
			// LForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.Black;
			this.ClientSize = new System.Drawing.Size(792, 566);
			this.ForeColor = System.Drawing.Color.White;
			this.Menu = this.mnuLunar;
			this.Name = "LForm";
			this.Text = "The Lunar Destroyer";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.LForm_KeyDown);
			this.Load += new System.EventHandler(this.LForm_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.LForm_Paint);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new LForm());
		}

		//inicializacia pri kazdom starte, nastavenie vs. premenne
		public void Inicializuj()
		{
			if (bDuel) 
				iPocetAst=0;
			Skore1=0;
			Skore2=0;
			Random R = new Random();
			AsteroidList = new ArrayList();
			//vygenerovanie asteroidov
			for(int i=0;i<iPocetAst;i++)
			{
				// polozi asteroidy prec z centra
				int x = R.Next(this.ClientRectangle.Width);
				if ((x > this.ClientRectangle.Width/3) && (x < (2*this.ClientRectangle.Width/3)))
					x -= (this.ClientRectangle.Width/3);
				
				int y = R.Next(this.ClientRectangle.Height);
				if ((y > this.ClientRectangle.Height/3) && (y > (2*this.ClientRectangle.Height/3)))
					y -= (this.ClientRectangle.Height/3);

				//prida do pola
				AsteroidList.Add(new Asteroid(x,y,R.Next(360)));
			}

			float otocenie=270;		//uhol otocenia vygenerovanych lodi
			int delta=50;
			Color cfarba1 = Color.Aqua;
			Color cfarba2 = Color.Red;

			switch (iHrac) 
			{
				case 0: //hrac
					Hrac1 = new HI(this.ClientRectangle.Width/2,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie+90,cfarba1);
					Hrac2 = null;
					break; 
				case 1: //pocitac
					Hrac2 = new AI(this.ClientRectangle.Width/2,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie+90,cfarba2);
					Hrac1 = null;
					break;
				case 2: //obaja
					Hrac1 = new HI(this.ClientRectangle.Width/2-delta,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie,cfarba1);
					Hrac2 = new AI(this.ClientRectangle.Width/2+delta,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie+180,cfarba2);
					break;
				case 3: //obaja su hraci
					Hrac1 = new HI(this.ClientRectangle.Width/2-delta,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie,cfarba1);
					Hrac2 = new HI(this.ClientRectangle.Width/2+delta,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie+180,cfarba2);
					break;
				case 4: //obaja su hraci
					Hrac1 = new AI(this.ClientRectangle.Width/2-delta,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie,cfarba1);
					Hrac2 = new AI(this.ClientRectangle.Width/2+delta,this.ClientRectangle.Height/2,mnuZotrvacnost.Checked,otocenie+180,cfarba2);
					break;
				default:
					break;
			}
		}
		//Koniec pri zostreleni lode
		private void Koniec(string _meno)
		{
			Ltimer.Stop();
			MessageBox.Show("Prehral"+_meno+" hrac!");
		}
		//pri vyhre
		private void VyhraSoSkore(string _meno,int skore)
		{
			Ltimer.Stop();
			MessageBox.Show("Vyhral"+_meno+" hrac!\nDosiahol skore "+skore+".");
		}

		//pri hre bez asteroidov
		private void Vyhra(string _meno)
		{
			Ltimer.Stop();
			MessageBox.Show("Vyhral"+_meno+" hrac!");
		}
		
		//existencia hracov,vyhodnotenie kto vyhral
		//obnova formulara, aby sa prekreslili vsetky objekty
		private void Ltimer_Tick(object sender, System.EventArgs e)
		{
			//nebol duel - kontrolujeme i na pocet asteroidov
			if (!bDuel)
			{
				//obaja zlikvidovany rovnaky cas
				if ((Hrac1!=null) && (!Hrac1.Aktivny) && (Hrac2!=null) && (!Hrac2.Aktivny))
					Koniec(" 1. ("+Skore1+") aj 2. ("+Skore2+")");
				else
					//iba jeden
					if ((Hrac1!=null) && (!Hrac1.Aktivny))
						Koniec(" 1.");
					else
						if ((Hrac2!=null) && (!Hrac2.Aktivny))
							Vyhra(" 1.");
						else
							if( AsteroidList!=null && AsteroidList.Count==0)
								if (Skore1>Skore2) 
									VyhraSoSkore(" 1",Skore1);
								else
									if(Skore1<Skore2)
										VyhraSoSkore(" 2",Skore1);
									
			} 
			else		//bol duel kontrolujeme - kto koho zabil
			{
				if ((Hrac1!=null) && (!Hrac1.Aktivny) && (Hrac2!=null) && (!Hrac2.Aktivny))
					Koniec(" 1. aj 2.");
				else
				{
					if ((Hrac1!=null) && (!Hrac1.Aktivny))
						Koniec(" 1");
					if ((Hrac2!=null) && (!Hrac2.Aktivny))
						Koniec(" 2");
				}
			}
			//dolezite pre prekreslenie
			this.Refresh();
		}

		// pohne nabojom
		private void PohniNaboj(Naboj Strela)
		{
			Strela.Pohyb();
			if (Strela.VnutriStvorca(this.ClientRectangle))
				Strela.Aktivny = false;
		}
		//pohnutie nabojov a kolizie nabojov s lodami 
		private void KolPohniNabojeLode(Naboj[] Naboje,vesLod Lod1,vesLod Lod2)
		{
			//pohne nabojmi
			for(int i=0;i<Naboje.Length;i++)
			{
				// je tam Naboj?
				if ((Naboje[i]!=null) && (Naboje[i].Aktivny))
				{	
					//pohne nabojom
					PohniNaboj(Naboje[i]);
					// testuje koliziu lodi a nabojov
					KolizieNabLod(Naboje[i],Lod1);
					KolizieNabLod(Naboje[i],Lod2);
				}
			}
		}
		// pohyb vesmirnych lodi
		private void PohniLodou(vesLod Lod)
		{
			if ((Lod != null) && Lod.Aktivny) 
			{
				bool hracik = Lod.Hrac(); 
				if (Lod.Hrac()) 
					Lod.Pohyb();
				else
					Lod.Prezi(AsteroidList);
				Lod.VnutriStvorca(this.ClientRectangle);				
			}
		}
		// pohyb asteroidov
		private void PohniAsteroidy(ArrayList Asteroidy)
		{
			foreach(Asteroid A in Asteroidy)
			{
				A.Pohyb();
				//otestuje ci su vsetky vnutri
				A.VnutriStvorca(this.ClientRectangle);
			}
		}
		// kolizia asteroidu s nabojom
		private bool KolizieAstNab(Naboj Strela,Asteroid A)
		{
			if(Strela.NarazilDo(A.Okraje(),A.AsteroidImg))
			{
				A.Exploduje=true;			//nastavime Asteroidu exploziu
				Strela.Aktivny = false;		//zneaktivizujeme naboj
				return true;
			} else
				return false;
		}
		//kolizia asteroidu s nabojmi (podla odkazu sa zistuje skore)
		private void KolizieAstNaboje(Naboj[] Naboje,Asteroid A,ref int skore)
		{
			foreach(Naboj Nab in Naboje)
			{
				if ((Nab!=null) && (Nab.Aktivny))
				{
					if (KolizieAstNab(Nab,A)) 
						skore++;
				}
			}
		}
		// kolizia naboja s lodou
		private void KolizieNabLod(Naboj Strela,vesLod Lod)
		{
			if ((Lod!=null) && (Lod.Aktivny))
			{
				if (Strela.NarazilDo(Lod.Okraje(),Lod.LodImg))
				{
					Strela.Aktivny = false;
					Lod.Aktivny = false;
				}
			}
		}

		// kolizia asteroidu s lodou
		private void KolizieAstLod(Asteroid A,vesLod Lod)
		{
			if (Lod.NarazilDo(A.Okraje(),A.AsteroidImg))
			{
				A.Exploduje=true;
				Lod.Aktivny=false;
			}
		}
		//kolizie asteroidov s lodami a ich nabojmi
		private void KolizieAsteroidov(ArrayList Asteroidy,vesLod Lod1,vesLod Lod2)
		{
			foreach(Asteroid A in Asteroidy)
			{
				// ak exploduje,nic sa nerobi
				if (A.Exploduje==false)
				{					
					// skontroluje koliziu s hracom1 a nabojmi
					if((Lod1!=null) && (Lod1.Aktivny))
					{
						KolizieAstLod(A,Lod1);
						KolizieAstNaboje(Lod1.Naboje,A,ref Skore1);
					}
					// skontroluje koliziu s hracom2 a nabojmi
					if((Lod2!=null) && (Lod2.Aktivny))
					{
						KolizieAstLod(A,Lod2);
						KolizieAstNaboje(Lod2.Naboje,A,ref Skore2);
					}
				}
			}
		}
		
		//kolizie dvoch lodi
		private void KolizieLodLod(vesLod Lod1,vesLod Lod2)
		{
			if((Lod1!=null) && (Lod2!=null) && (Lod1.Aktivny) && (Lod2.Aktivny))
			{
				if (Lod1.NarazilDo(Lod2.Okraje(),Lod2.LodImg))
				{
					Lod1.Aktivny = false;
					Lod2.Aktivny = false;
				}
			}
		}
		// vesmir - simuluje vsetky interakcie medzi objektami
		private void Space()
		{
			// pohyb vesmirnych lodi
			PohniLodou(Hrac1);
			PohniLodou(Hrac2);
			// kontrola kolizie dvoch lodi
			KolizieLodLod(Hrac1,Hrac2);
			//pohneme nabojmi a riesime kolizie naboje-lode
			if (Hrac1!=null) 
				KolPohniNabojeLode(Hrac1.Naboje,Hrac1,Hrac2);
			if (Hrac2!=null)
				KolPohniNabojeLode(Hrac2.Naboje,Hrac1,Hrac2);
			// pohyb asteroidov
			PohniAsteroidy(AsteroidList);
			// skontroluje vsetky asteroidy na koliziu
			KolizieAsteroidov(AsteroidList,Hrac1,Hrac2);
		}		
		//vykreslime Naboje
		private void VykresliNaboje(Naboj[] Naboje, Graphics g)
		{
			for(int i = 0;i<Naboje.Length;i++)
				if (Naboje[i] != null)
					if (Naboje[i].Aktivny)
						Naboje[i].Kresli(g);
		}
		//vykreslovanie ... volane z timeru
		private void LForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if(!bZac)
			{
				String Slovo = "The Lunar Destroyer";
				Point Bod = new Point((this.ClientRectangle.Width/2) - (Slovo.Length*15),this.ClientRectangle.Height - NadpisPos);

				e.Graphics.DrawString(Slovo,new Font("Verdana",36),new SolidBrush(Color.Azure),Bod);
				if (!(NadpisPos > (this.Height/2)))
				{
					NadpisPos = NadpisPos + 5;
				}
			}
			else
			{
				/* DEBUG
				// vypisanie uhlov
				String TEXT = Convert.ToString(Hrac1.Smer);
				e.Graphics.DrawString(TEXT,new Font("Verdana",8),new SolidBrush(Color.Azure),new Point(3,3));
				TEXT = Convert.ToString(Hrac1.Rotuje);
				e.Graphics.DrawString(TEXT,new Font("Verdana",8),new SolidBrush(Color.Azure),new Point(3,13));
				TEXT = Convert.ToString(Hrac1.Rychlost);
				e.Graphics.DrawString(TEXT,new Font("Verdana",8),new SolidBrush(Color.Azure),new Point(3,25));
				// DEBUG END */
				Graphics g = e.Graphics;
				//prepocita vsetky pohyby a kolizie vo vesmire
				Space();
				/*-------vykreslenie vsetkeho--------*/

				// vykreslime prip. zrusime asteroidy
				for(int i = 0;i<AsteroidList.Count;i++)
				{
					Asteroid A = (Asteroid)AsteroidList[i];
					if (A.Aktivny)
						A.Kresli(g);
					else
					{
						AsteroidList.RemoveAt(i);
					}
				}
				//pole nabojov, aby sme ich mohli vykreslit
				if ((Hrac1!=null) && Hrac1.Aktivny)
				{
					VykresliNaboje(Hrac1.Naboje,e.Graphics);
					//vykreslime i lod
					Hrac1.Kresli(g);
				}
				if ((Hrac2!=null) && Hrac2.Aktivny)
				{
					VykresliNaboje(Hrac2.Naboje,e.Graphics);
					//vykreslime i druhu lod
					Hrac2.Kresli(g);
				}				
			}
		}
		/*--------Obsluha udalosti----------*/
		//nastavenie pri nacitani formulara
		private void LForm_Load(object sender, System.EventArgs e)
		{
			Ltimer.Enabled = true;
			Ltimer.Interval = 75;
		}
		
		private void mnuUkonc_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}
		private void mnuOhre_Click(object sender, System.EventArgs e)
		{
			Ltimer.Stop();
			MessageBox.Show("Zapotov program PRG30,2005,Marek Sadvar","O hre");
			Ltimer.Start();
		}

		private void mnuNova_Click(object sender, System.EventArgs e)
		{
			Ltimer.Stop();

			zac formular = new zac();
			if (formular.ShowDialog(this)==DialogResult.OK)
			{
				this.iHrac = formular.HracZac;
				this.bDuel = formular.DuelZac;
				this.iPocetAst = formular.PocetAst;
				Inicializuj();
				Ltimer.Start();
			}
			else
			{
				//nic
			}
			bZac = true;
			formular.Dispose();
		}

		private void LForm_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			//i kontrola ludskeho hraca
			if ((Hrac1!=null) && Hrac1.Hrac() && (Hrac1.Aktivny))
				switch (e.KeyData) 
				{
					case Keys.Up:	
						Hrac1.Akceleruj();			
						break;
					case Keys.Left:
						Hrac1.Dolava();
						break;
					case Keys.Right:
						Hrac1.Doprava();
						break;
					case Keys.L:
						Hrac1.Vystrel();
						break;
					default:
						break;
				}
			if ((Hrac2!=null) && Hrac2.Hrac() && (Hrac2.Aktivny))
				switch (e.KeyData) 
				{
					case Keys.W:	
						Hrac2.Akceleruj();			
						break;
					case Keys.A:
						Hrac2.Dolava();
						break;
					case Keys.D:
						Hrac2.Doprava();
						break;
					case Keys.Q:
						Hrac2.Vystrel();
						break;
					default:
						break;
				}
		}
		private void mnuZotrvacnost_Click(object sender, System.EventArgs e)
		{
			mnuZotrvacnost.Checked=!mnuZotrvacnost.Checked;
			if (Hrac1!=null)
				Hrac1.NabojZotr=mnuZotrvacnost.Checked;
		}

		private void mnuPauza_Click(object sender, System.EventArgs e)
		{
			bPauza = !bPauza;
			if(bPauza) {
				Ltimer.Stop();
			}
			else {
			Ltimer.Start();
			}
		}
		private void mnuPom_Click(object sender, System.EventArgs e)
		{
			Ltimer.Stop();
			Help h = new Help();
			h.ShowDialog(this);
		}
	}
}
